import mqtt from 'mqtt'
import Sensor from '../components/Sensor.js'

const updateSensor = (obj) => (dispatch, getState) => {

  var firstDate = "";

  let copyState = getState();

  // On parcours la liste de nos différents capteurs et on ajoute les nouvelles informations associées aux messages reçus
  for(var k = 0; k < copyState.sensor.length; k++) {

    if(copyState.sensor[k].name === obj.name) {

      var date = new Date();

      if(typeof copyState.sensor[k]._data.values !== "array" && copyState.sensor[k]._data.labels instanceof Date) {
        if(copyState.sensor[k].type !== 'ON_OFF') {

          var firstValue = copyState.sensor[k]._data.values;

          copyState.sensor[k]._data.values = [];
          copyState.sensor[k]._data.values.push(firstValue);
          copyState.sensor[k]._data.values.push(obj.value);
          firstDate = copyState.sensor[k]._data.labels;
          copyState.sensor[k]._data.labels = [];
          copyState.sensor[k]._data.labels.push(firstDate);
          copyState.sensor[k]._data.labels.push(date);
        }
        else {
          copyState.sensor[k]._data.values = obj.value;
          firstDate = copyState.sensor[k]._data.labels;
          copyState.sensor[k]._data.labels = [];
          copyState.sensor[k]._data.labels.push(firstDate);
          copyState.sensor[k]._data.labels.push(date);
        }
      }
      else {
        if(typeof copyState.sensor[k]._data.values === "string" && copyState.sensor[k].type === 'ON_OFF') {

          // A chaque changement des yeux
          copyState.sensor[k]._data.values = obj.value;
          copyState.sensor[k]._data.labels.push(date);

        }
        else
        {
          if(copyState.sensor[k]._data.values.length === 10 && copyState.sensor[k]._data.labels.length === 10) {

            for(var m = 0; m < copyState.sensor[k]._data.values.length; m++) {
                if(m !== copyState.sensor[k]._data.values.length) {
                  copyState.sensor[k]._data.values[m] = copyState.sensor[k]._data.values[m+1];
                  copyState.sensor[k]._data.labels[m] = copyState.sensor[k]._data.labels[m+1];
                }
            }

            copyState.sensor[k]._data.values.splice(-1, 1);
            copyState.sensor[k]._data.labels.splice(-1, 1);
            copyState.sensor[k]._data.values.push(obj.value);
            copyState.sensor[k]._data.labels.push(date);
          }
          else {

            copyState.sensor[k]._data.values.push(obj.value);
            copyState.sensor[k]._data.labels.push(date);
          }

        }
      }

      dispatch({ type: 'UPDATE_SENSOR', sensor: copyState.sensor[k], identifiant: k });

   }
  }
}

export function connexion_action(url) {
    return function (dispatch, getState) {

        dispatch({type: 'WAIT_CONNEXION'});

        return new Promise(function(resolve, reject){
            var client = mqtt.connect(url);

	    // Préfixe du Topic
		const prefixTopic = "value/";

		// Identifiant unique
		var id = 1;

		// Première date reçu


            client.on('connect', function () {
                client.subscribe("#");
                resolve();
            });

            client.on('message', function (topic, message) {
              const obj = JSON.parse(message.toString());


              var name = topic.replace(prefixTopic,"");

              obj.id = id;
              obj.name = name;

              if(obj.type !== "ON_OFF") {
          		    obj.value = parseFloat(obj.value);

          		    if(obj.type === "PERCENT") {
          		      obj.value = (Math.round(obj.value * 10) / 10)*100;
          		    }
          		    else {
          		      obj.value = Math.round(obj.value * 10) / 10;
          		    }
	            }

              id++;

              if(!getState().listCapteurs.contains(name)) {

                  var data = {};
                  data.values = obj.value;
                  data.labels = new Date();
                  obj.data = data;
                  dispatch({ type: 'ADD_SENSOR_NAME', capteurs: name });
                  dispatch({ type: 'ADD_SENSOR_OBJECT', capteurs: new Sensor(obj) });

              }else{

                  //updateSensor(obj);
                  dispatch(updateSensor(obj));

              }
          })
        })
        .then(() => dispatch({type: 'CONNEXION_OK'}))
        .catch(() => dispatch({type: 'CONNEXION_KO'}))
    }
}
