import React from 'react'
import { connect } from 'react-redux'
import {
  Route
} from 'react-router-dom';
import '../index.css';
import Infos from './Infos'

let Content = (props) => {

    for(var i = 0; i < props.sensor.length; i++) {

      if(props.match.params.capteurSelected === props.sensor[i].name && props.sensor[i].name === props.match.params.capteurSelected) {

        // On créé une array spécifique à chaque sensor (affiche toutes les données attendues pour l'historique)
        let sensor = props.sensor[i];
        let arr = [];

        // On crée 2 variables qui permettront d'afficher le résultat sous une meilleure forme.
        var sensor_values_read = "";
        var type_sensor_value = "";

        switch(sensor.type) {
          case "TEMPERATURE": sensor_values_read = "Température actuelle : " + sensor.lastValue+"°C"; break;
          case "ON_OFF": sensor_values_read = "Etat de mes yeux : " + sensor.lastValue; break;
          case "PERCENT": sensor_values_read = "Pourcentage actuel : " + sensor.lastValue+"%"; break;
          default: sensor_values_read = "Capteur : " + sensor.name + " ; Valeur courante : " + sensor.lastValue; break;
        }

        switch(sensor.type) {
          case "TEMPERATURE": type_sensor_value = "Température"; break;
          case "ON_OFF": type_sensor_value = "On_off"; break;
          case "PERCENT": type_sensor_value = "Pourcentage %"; break;
          default: type_sensor_value = "Valeur courante"; break;
        }

        // Check si on a plusieurs valeurs à afficher dans l'historique
        if(typeof sensor.value === 'object' && sensor.value.length !== undefined) {

          /* Transformer les données dans une seul array pour chaque sensor */
          for(var i = 0; i < sensor.value.length; i++) {
              arr.push([{'labels': sensor.labels[i], 'value': sensor.value[i]}]);
          }


          var idKey = 1;

          // On affiche l'historique en Real-Time
          var historique = arr.map(function(response) {

              return (
                <tr key={idKey=idKey+1}>
                <td key={response[0].value}>
                  {response[0].value}
                </td>
                <td key={response[0].labels}>
                  {response[0].labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' })}
                </td>
                </tr>
              );
          });
        }

        return (
          <article>
              <div id="messageList" className="table-block footer-push">
                <div id="content">
            <div><h1>{sensor_values_read} (<i>Date de dernière mise à jour : {sensor.lastDate}</i>)</h1>

            <br />

            <table border="1">
              <thead>
              <tr>
                <th colSpan={2}><h1>Historique</h1></th>
              </tr>
              <tr>
                <th>{type_sensor_value}</th>
                <th>Dernière maj</th>
              </tr>
              </thead>
              <tbody>
                {historique || <tr><td colSpan={2}>Aucun historique disponible pour ce capteur</td></tr>}
              </tbody>
            </table></div>
            </div>
          </div>
      </article>
        );

      }

    }

    return (
    <article>
        <div id="messageList" className="table-block footer-push">
          <div id="content">
            <h1>Bienvenue sur mon application Web-App comportant ReactJS + Redux</h1>
          </div>
        </div>
    </article>
    );
};

Content = connect(
    function mapStateToProps(state) {
        return {sensor: state.sensor}
    },
    (dispatch) => ({submit: (action) => dispatch(action)})
)(Content);

export default Content
