import React from 'react'
import { connect } from 'react-redux'
import { Sensor } from '../components/Sensor'
import { connexion_action } from '../actions'
import mqtt from 'mqtt'

Array.prototype.contains = function(obj) {
  var i = this.length;
  while (i--) {
      if (this[i] === obj) {
          return true;
      }
  }
  return false;
}

let Form = ( props ) => {
  let input

  function chargement(){
      switch(props.connecting){
          case 0 : return "Connexion échouée";
          case 1 : return "Connexion réussie";
          case 2 : return "Chargement en cours";
          default : return "Tester la connexion";
      }
  }

  return (
      <form onSubmit={e => {
            e.preventDefault();
            props.submit(connexion_action(input.value))
        }}>

        <label>
            URL du Brocker :
        </label>
        <input type="text" required placeholder="ws://127.0.0.1:8080" pattern="(ws|mqtt):\/\/(.*)" ref={node => {input = node}} />
        <input type="submit" value={chargement()}/>
        </form>
  )
}

Form = connect(
    function mapStateToProps(state) {
        return {connecting: state.connecting}
    },
    (dispatch) => ({submit: (action) => dispatch(action)})

)(Form)

export default Form
