import React from 'react'
import ReactDOM from 'react-dom';
import { createStore, applyMiddleware, combineReducers } from 'redux';
import reducer from './reducers/index.js'
import Root from './components/Root'
import thunkMiddleware from 'redux-thunk';
import './index.css';

const initialState = {
  listCapteurs: [],
  sensor: [],
  connecting : 3
};

const store = createStore(reducer, initialState, applyMiddleware(
    thunkMiddleware
));

/* Mode DEBUG */
/*store.subscribe(() =>
  console.log(store.getState())
)*/

ReactDOM.render((
   <Root store={store} />
), document.getElementById('root'));
